#include "msg.h"
int openMsg(key_t key)
{
  int mid;
  if( ( mid = msgget( key , IPC_CREAT|0660) )==-1 )
  {
    perror("open is error");
    exit(1);
  }
  return mid;
}
int writeMsg(int mid ,struct msgbuf *mbuf)
{
  int rs;
  int len = sizeof(struct msgbuf)-sizeof(long);
  if( rs =msgsnd(mid,mbuf,len,0)==-1 )
  {
    perror("write is error");
    exit(1);
  }
  return rs; 
}

int readMsg(int mid,long mtype,struct msgbuf *mbuf)
{
  int rs;
  int len = sizeof(struct msgbuf)-sizeof(long);

  if((rs=msgrcv(mid,mbuf,len,mtype,0))==-1)
  {
    perror("read is error");
    exit(1);
  }
  return rs;
}

int msg_exist(int mid,long mtype)
{
  int rs;
  if( (rs=msgrcv(mid,NULL,0,mtype,IPC_NOWAIT))==-1 )
  {
    if(errno==E2BIG)
    {
      return 1;
    }else{
      perror("exist is error");
      exit(0);
    }
  }
  return 0;
}

void delMsg(int mid)
{
  if( msgctl(mid,IPC_RMID,0)==-1 )
  {
    perror("delete fail:");
    exit(0);
  }
  printf("delete success!\n");
}

void modifyMsg(int mid,char *mode)
{
  struct msqid_ds mds;
  
  msgctl(mid,IPC_STAT,&mds);
  sscanf(mode,"%ho",&mds.msg_perm.mode);
  msgctl(mid,IPC_SET,&mds);
}
